VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form DemoForm 
   Caption         =   "NetPorter DAQ Demo"
   ClientHeight    =   2175
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4050
   LinkTopic       =   "Form1"
   ScaleHeight     =   2175
   ScaleWidth      =   4050
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Recon 
      Caption         =   "Reconnect"
      Height          =   495
      Left            =   2640
      TabIndex        =   6
      Top             =   600
      Width           =   1095
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   2640
      Top             =   1320
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      Handshaking     =   2
      NullDiscard     =   -1  'True
      RThreshold      =   1
      BaudRate        =   19200
   End
   Begin VB.Label Status 
      Caption         =   "No Data Yet"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   1920
      Width           =   3855
   End
   Begin VB.Label A0 
      Height          =   375
      Left            =   600
      TabIndex        =   5
      Top             =   120
      Width           =   1815
   End
   Begin VB.Label D0 
      Height          =   375
      Left            =   600
      TabIndex        =   4
      Top             =   1320
      Width           =   1815
   End
   Begin VB.Label Label1 
      Caption         =   "A0:"
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   255
   End
   Begin VB.Label Label2 
      Caption         =   "D0:"
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   1320
      Width           =   255
   End
   Begin VB.Label Label3 
      Caption         =   "A1:"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   255
   End
   Begin VB.Label A1 
      Height          =   375
      Left            =   600
      TabIndex        =   0
      Top             =   720
      Width           =   1815
   End
End
Attribute VB_Name = "DemoForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' This is an example of using the NetPorter DAQ ActiveX
' from Visual Basic. -- Al Williams http://www.al-williams.com

' Create a NetPorter-compatible module
Dim NetPorter As New AWCNetPorter.NetPorter

Private Sub Form_Load()
Set NetPorter.Callback = Me  ' Register myself to listen for ProcessLine
Set NetPorter.OnChange = Me  ' And for change callbacks too
Recon_Click  ' connect
End Sub

Private Sub MSComm1_OnComm()
If MSComm1.CommEvent = comEvReceive Then
' Pass all serial data to NetPorter module
 NetPorter.CommData (MSComm1.Input)
End If
If MSComm1.CommEvent >= 1000 Then
  Recon_Click  ' try to recover from an error
End If
End Sub

Public Function ProcessLine(l As String) As String
' This function is optional, but if you provide it, you must return
' the processed line
' For example, suppose the device writes out: 42 lbs
' and you want to change it to wgt=42
' you might write:
' x=Instr(l," ")
' ProcessLine = "wgt=" & Left(l,x-1)
' If you don't want to process lines, either don't provide this function
' and remove the line that sets the callback in Form_Load
' Or just return the input

Debug.Print l  ' let's look at what we are processing
' For this example, we will change D0 into hex format just to show how
If Left(l, 3) = "D0=" Then
  ProcessLine = "D0=" & Hex(Val(Mid(l, 4)))
Else
  ProcessLine = l   ' pass it along if we don't care
End If
End Function

Public Sub OnChangeData(k As String)
' This Sub is optional. It is called whenever something is
' put in the data array
On Error Resume Next  ' in case we get garbage!
' This tricky code needs a little explanation
' Say, A0 changed, then k=A0
' Me.controls(k) then refers to a label named "A0" on the form (if any)
' So all you have to do is put a label that refers to an input
' variable on the form and it magically gets the value in it!
Me.Controls(k).Caption = NetPorter.GetVar(k)
Status.Caption = "Data received " & Now
End Sub


' This just manages a (re)connect
Private Sub Recon_Click()
If MSComm1.PortOpen Then MSComm1.PortOpen = False
NetPorter.Reset
MSComm1.PortOpen = True
MSComm1.RTSEnable = True
End Sub
